package domaintree64

// !!!DON'T EDIT!!! Generated by infobloxopen/go-trees/etc from <name>tree{{.bits}} with etc -s uint64 -d uintX.yaml -t ./<name>tree\{\{.bits\}\}

import "github.com/infobloxopen/go-trees/domain"

type labelTree struct {
	root *node
}

type labelPair struct {
	Key   string
	Value *Node
}

func newLabelTree() *labelTree {
	return new(labelTree)
}

func (t *labelTree) insert(key string, value *Node) *labelTree {
	var (
		n *node
	)

	if t != nil {
		n = t.root
	}

	dl, _ := domain.MakeLabel(key)
	return &labelTree{root: n.insert(dl, value)}
}

func (t *labelTree) rawInsert(key string, value *Node) *labelTree {
	var (
		n *node
	)

	if t != nil {
		n = t.root
	}

	return &labelTree{root: n.insert(key, value)}
}

func (t *labelTree) inplaceInsert(key string, value *Node) {
	dl, _ := domain.MakeLabel(key)
	t.root = t.root.inplaceInsert(dl, value)
}

func (t *labelTree) rawInplaceInsert(key string, value *Node) {
	t.root = t.root.inplaceInsert(key, value)
}

func (t *labelTree) get(key string) (*Node, bool) {
	if t == nil {
		return nil, false
	}

	dl, _ := domain.MakeLabel(key)
	return t.root.get(dl)
}

func (t *labelTree) rawGet(key string) (*Node, bool) {
	if t == nil {
		return nil, false
	}

	return t.root.get(key)
}

func (t *labelTree) enumerate() chan labelPair {
	ch := make(chan labelPair)

	go func() {
		defer close(ch)

		if t == nil {
			return
		}

		t.root.enumerate(ch)
	}()

	return ch
}

func (t *labelTree) rawEnumerate() chan labelPair {
	ch := make(chan labelPair)

	go func() {
		defer close(ch)

		if t == nil {
			return
		}

		t.root.rawEnumerate(ch)
	}()

	return ch
}

func (t *labelTree) del(key string) (*labelTree, bool) {
	if t == nil {
		return nil, false
	}

	dl, _ := domain.MakeLabel(key)
	root, ok := t.root.del(dl)
	return &labelTree{root: root}, ok
}

func (t *labelTree) rawDel(key string) (*labelTree, bool) {
	if t == nil {
		return nil, false
	}

	root, ok := t.root.del(key)
	return &labelTree{root: root}, ok
}

func (t *labelTree) isEmpty() bool {
	return t == nil || t.root == nil
}

func (t *labelTree) dot() string {
	body := ""

	if t != nil {
		body = t.root.dot()
	}

	return "digraph d {\n" + body + "}\n"
}
